package org.bitbucket.bradleysmithllc.etlunit.feature.informatica;

import org.bitbucket.bradleysmithllc.etlunit.TestExecutionError;
import org.bitbucket.bradleysmithllc.etlunit.feature.informatica.util.InformaticaRepositoryClient;

/*
			dev_pc_repo: {}
*/
public class InformaticaRepository {
	private final String repositoryName;
	private final InformaticaDomain informaticaDomain;
	private final InformaticaFeatureModule informaticaFeatureModule;

	private InformaticaRepositoryClient informaticaRepositoryClient;

	public InformaticaRepository(InformaticaDomain domain, String name, InformaticaFeatureModule module) {
		repositoryName = name;
		informaticaDomain = domain;
		informaticaFeatureModule = module;
	}

	public String getRepositoryName() {
		return repositoryName;
	}

	public String getQualifiedName()
	{
		return informaticaDomain.getDomainName() + "." + repositoryName;
	}

	public InformaticaRepositoryClient getInformaticaRepositoryClient() throws TestExecutionError
	{
		if (informaticaRepositoryClient == null)
		{
			informaticaRepositoryClient = informaticaFeatureModule.getRepositoryClientImpl(this);
		}

		return informaticaRepositoryClient;
	}

	public InformaticaDomain getInformaticaDomain()
	{
		return informaticaDomain;
	}

	public void dispose()
	{
		if (informaticaRepositoryClient != null)
		{
			informaticaRepositoryClient.dispose();
		}
	}
}